
;----------------------------------------------------------------------------------
; Quell-Programm speedy2
;=======================
;
;Freigabe nur fuer den nichtkommerziellen Gebrauch !!!

;Vorsicht bei nderungen, es knnten sich fatale Folgen ergeben, wie z. B.:
;	- gleichzeitiges Durchschalten von Fahrt- und Bremstransistoren
;		(im gnstigsten Fall wird dabei nur der Bremstransistor zerstrt)
;	- fehlerhafte Unterspannungsbehandlung (kann zur Unsteuerbarkeit
;		des Modells fhren;
;	- Beeintrchtigung der Sicherheit und daher Verletzungsgefahr
;		(der Motor knnte unerwartet anlaufen)
;	- und vieles andere mehr;
;
;Sollten trotzdem nderungen vorgenommen werden mssen, bitte eventuell Rcksprache
;halten, und dann natrlich ausgiebig testen;
;
;
;Rechtliches (muss leider auch erwhnt werden):
;----------------------------------------------
;Ich bernehme keine Verantwortung fr Schden und Verletzungen, die durch Bau
;und Betrieb dieses Fahrtreglers entstehen.
;Fr die ordnungsgeme Programmierung und den sicheren Betrieb ist alleine der
;jeweilige Projektbetreiber zustndig.
;Fuer die Fehlerfreiheit der vorliegenden Programm-Version kann natrlich nicht 
;garantiert werden,
;
;Johann Aichinger
;----------------------------------------------------------------------------------


	LIST            P=16F84 ; no need to change this for the 16C84
        ERRORLEVEL      -302    ;SUPPRESS BANK SELECTION MESSAGES
        __CONFIG        3FF5H	;5 fr F84, D fr C84

			; B4:   CODE PROTECTION, 1=OFF
			; B3:   POWER UP, 0=TIMED bei F84
			; B2:   WDOG, 1=ON
			; B1-0: OSC SELECT, 01=XT, 11=RC



; nderungsliste:
; ---------------
; *2) Bremse programmierbar
; *3) 23.12.98 bei leerlauf rcknahme d. leistungsdrosselung
; *4) 21. 2.99 watchdogtimer eingebaut (anlauf=77H --> keine sperre) 
; *5) 12. 4. 99 einige Fehler bei der Unterspannungs-Behandlung
; *6) 16. 4. 99 led bei notpgm loe
; *7) 10. 6. 99 Resonatorbetrieb 	          	
; *8)   .11. 99 Softanlauf, Softbremse, motorpieps, 3,5khz, Sicherheit
;		umstellung auf neues layout
; *9)   .11. 99 herantasten an die belastungsgrenze (tuspg wieder erhoehen)
;		nach ablauf des durchlaufzhlers uspgz
; *10) 1. 2000	Softanlauf etwas beschleunigt	
; *11) 2. 2000	Softbremsvorgang kann durch Gasgeben unterbrochen werden 
; *12) 2. 2000	bei leerwerdendem akku: auswertung d. knueppelstellung im unteren
;		anstatt im oberen bereich; ab einem bestimmten unterspannungszustand
;		motor abstellen und einbremsen (falls programmiert).
; *13) 24. 5. 2000  manche computersender ueberschritten das zeitlimit beim empfang
; *14) 2. 10. 2000  Vollgas-Verzoegerung beim Erstart behoben

TMR0	equ	1
PCL     equ     2
STATUS  equ     3                       ;standard register files
PORTA   equ     5
PORTB   equ     6
EEDATA  equ     8
EEADR   equ     9
INTCON  equ     0BH
OPTREG  equ     081H
TRISA   equ     085H
TRISB   equ     086H
EECON1  equ     088H
EECON2  equ     089H

;
C	equ	0		;carry bit in status
RP0     equ     5                       
Z       equ     2
GIE     equ     7
INTF	equ	1		;RB0 change
T0IE    equ     5
T0IF    equ     2
RBIE	equ	3		;interrupt eingang mgl.
RBIF	equ	0		;Interrupt eingang aufgetreten
WREN    equ     2
WR      equ     1
RD      equ     0
EEIE	equ	6
EEIF	equ	4

dl1	equ	d'125'		;durchlaufzhler 1 fr interrupt(125)
dl2	equ	d'10'		;durchlaufzhler 2 fr senderausfall

;	I/O pins porta
;	--------------
led	equ	0		;leuchtdiode RA0
setu	equ	1		;set-eingang Ra1
motor	equ	2		;Ra2 ausgang (Motor)
osci	equ	3		;Ra3 oszillator fr spg-verdoppler

;	I/O pins portb
;	--------------

uspg	equ	2		;eingang: RB2 unterspannung, 
empf	equ	6		;eingang RB6 (Empfngersignal)
bremse	equ	4		;motor-bremse RB4
fehl	equ	7		;nur fr test

dist1	equ	3		; *8) 3 statt 4, leerlauf/vollgas-toleranz
				;zusammenhang mit presc!!!!!!!!
dist2	equ	d'6'		; *8) 6 statt 5, impuls darf um diesen timerwert 
				;vom normal-bereich abweichen, muss unbedingt
				;grsser als dist1 (ca.2xdist1) sein, da beim setup
				;dist1 auf ipmin u. ipmax auf/abgerechnet wird
				;zusammenhang mit presc!!!!!!!!

presc	equ	43H		; *8) prescaler 3 statt 4, pos RB0 flanke
ftol	equ	d'20'		;*13) 20 statt 40, fanz wird bei
				;interrupt erhht und erniedrigt, ab diesem
				;wert notprogramm (motor aus, staby bit2 setzen
				;....prfen
;
	;--------------------------
	;generelle Arbeits-Register
	;--------------------------
	CBLOCK  0CH             ;define variables required
	ipmax			;Impulsdauer vom Empf. 	maximal
	ipmin			;	"		minimal
	ipakt			;	"		aktuell
	stabya			;statusbyte,
				;bit0 kennzeichen revers:ipmin ist vollgas
				;bit3 1: Softanlauf *8)
				;bit4 1: mit EMK-Bremse
				;bit5 1: softbremse *8)	
				
				;bit6 = 1 --> wird beim 1.mal tein=0 gesetzt
				;	bremszhler geladen und nach x durch-
				;	lufen wird gebremst,
				;	wird bei tein>0 gelscht
				;bit7 setup luft, info fr interrupt-routine

	stabyb
				;bit0 akkute unterspannung, bremsen
				;bit1 motor kann erst laufen, wenn gas-
				;hebel auf 0 war (interrupt:tein=0)
				;bit2 reif frs notprogramm
				;bit3 letzter impuls war fehlerhaft
				;bit6 eingebremst
				;bit7 temporr	
	tmax			;Zyklusdauer (<=255)
	tein			;Timerschritte Motor 	ein
	taus			;	"		aus (taus+tein=tmax)
	tvor			;Hilfsfeld		tvor+tmax=255

	teinz
	tausz
	tealt			;letzte tein, wegen softanlauf *8)
	taalt			;letzte taus, wegen softanlauf *8)
	W_TEMP			;zum Sichern von W
	STATUS_TEMP		;zum Sichern von STATUS
	T_TEMP			;zum Sichern von TMR0
	durchl			;durchlauf-zhler
	sreg			;zhler fr notpgm
	senda			;zhler fr senderausfall
	senda1			;zhler fr senderausfall
	fanz			;anzahl fehlerhafter impulse, wird bei interrupt
				;erniedrigt oder erhht, ab ftol setze
				;staby-bit2 fuer notprogramm

	breza			;bremszhler (nach X mal tein=0 --> bremsen
	terl			;wird bei jedem unterspannungsfall
				;verkleinert, um tein u taus anzupassen
	uspgz			;zhler, nach ablauf wird terl wieder um 1 vergr,
				;dient zum herantasten an die akku-belastungsgrenze

	anlauf			;wenn 77H nach reset --> anlauf mglich 
				;(war controllerabsturz, ev.watchdog-timer)
	
	arb1			;arbeitsregister
	arb2			;arbeitsregister

	endc


;---------------------------------------------------------
;	P R O G R A M M  -- S T A R T 
;---------------------------------------------------------
	ORG     0
        goto	inti		; sprung ins hauptprogramm

	org	4
	goto	interr		; sprung in die Interrupt-Routine
				; bei empfngerflanke



;*********************************
; Initialisierung
;*********************************
;
inti
	clrf	PORTB
	bsf	PORTA,motor	; motor aus
	nop
inti0
	clrf	INTCON		; loe GIE ....
	btfsc	INTCON,7	;gie gelscht ???
	goto	inti0
	call	wartmal
	BSF     STATUS,RP0      ; select register bank 1
	movlw	presc		; asign prescaler 1:x to tmr0
	movwf	OPTREG		; da sonst timer berluft
	CLRF    TRISA
	CLRF	TRISB
	BSF	TRISB,empf     	; empfnger / eingang
	BSF	TRISA,setu	; setup-taster / eingang
	BSF	TRISB,uspg	; unterspannung / eingang
	BSF	TRISB,0		; RB0 / eingang (liegt layout-bedingt auf +VDD)
	nop
	BCF     STATUS,RP0      ; reselect bank 0
	CLRF    PORTA
	clrwdt		;*4)
	nop
	nop
	nop
	nop
	nop
	clrf	uspgz		;impulszhler f. herantasten an akku-belast-grenze 
	incf	uspgz,1		;darf nicht 0 sein
	clrf	terl		;*12)
	CLRF    ipmax
	CLRF    tvor
	CLRF    tein
	movlw	d'255'
	movwf	ipmin
	clrf	stabya		
	clrf	stabyb
;------------------------------------------------------------------
;	lese	minimale und maximale impulslnge falls abgespeichert
;	51=daten vorh, ipmin, ipmax, bit0=1:revers:ipmin=vollgas
; place byte to be written in EEDATA and the data EEPROM address in EEADR
; then call EEREAD

nxt0

	movlw	0		;adresse
	call	eeread		;hole kennz daten vorhanden
	sublw	d'51'		;vorhanden?
	btfsc	STATUS,Z
	goto	nxt1		;ja, vorhanden	
	goto	nxt2

nxt1
	movlw	1		;hole ipmin
	call	eeread
	movwf	ipmin		;und im arbeitsspeicher ablegen
	movlw	2		;hole ipmax
	call	eeread
	movwf	ipmax		;ablegen
	movlw	3		;hole status-byte(kennzeichen revers,bit0)
	call	eeread
	movwf	stabya		;bit0=1: revers: ipmin=vollgas

	movf	ipmin,0		;impulsdauer-min ins w-reg
	subwf	ipmax,0		;	"   -min von max abziehen-->w
	movwf	tmax		;Ergebnis nach tmax

	sublw	D'255'		;255 - tmax -->w
	movwf	tvor		;in tvor(lauf) abspeichern

nxt2
	bcf	stabyb,1	;*8) anlaufsicherung

	movlw	77H		;*4)
	subwf	anlauf,0	;*4)
	btfss	STATUS,Z	;*4)
	goto	notpgm		;teste sender
	bsf	stabyb,1	;*4)anlaufsicherung lsen da reset



;********************************************************************
;	schleife fuer normalbetrieb
;	---------------------------
;********************************************************************
genloop
	clrwdt				;*4)
	movf	tein,0
	movwf	teinz
	movf	taus,0
	movwf	tausz

	call	bedosci		;oscillator bedienen
	movf	tein,1		;einschaltzeit = 0 ?
	btfsc	STATUS,Z	
	goto	prbre		;keine einschaltzeit, prfe ob bremsen
				;retour nach cset
;	einschalteprozedur
;	------------------
eweit1
	btfsc	PORTB,uspg	;ist unterspannung gesetzt ? --> untersp
	goto	untersp		;lbit,setzezeiten,zurckaweit0
	bcf	PORTB,bremse	;lse bremse
eweit2
	bcf	PORTA,motor	; *8) M O T O R   E I N 
	btfsc	PORTB,uspg	;ist unterspannung gesetzt ? --> untersp
	goto	untersp		;reduziere Motorzeit, zurck nach aweit0
	decfsz	teinz,1
	goto	eweit2
cset
	call	bedosci		;oscillator bedienen
	btfss	PORTA,setu
	call	setup		;setup

;	ausschalteprozedur
;	------------------
aweit0
	MOVLW	88H		; RBIE(port B change interr.) + GIE yyy
	MOVWF	INTCON		; interrupt mglich	

	movf	tausz,1		;tausz=0 ? -->fert
	btfsc	STATUS,Z
	goto	fert
aweit1
	bsf	PORTA,motor	; *8) M O T O R   A U S
	decfsz	tausz,1
	goto	aweit1

fert
	call	bedosci		;oscillator bedienen
	btfsc	stabyb,2	;zu viele fehlerimpulse?
	goto	notpgm

	decfsz	senda,1		;senderausfall? (senda wird bei jedem gutimpuls geloescht)
	goto	genloop		;nein
	decfsz	senda1,1	;*13) senderausfall? (senda1 wird bei jedem gutimpuls gesetzt)
	goto	genloop		;*13)
;***********************************************************************************
;	Schleife bei empfangsproblemen, akkuter unterspannung, motor scharfschalten
;***********************************************************************************
;-----------------------------------------------------------------
notp	bcf	stabyb,1	;*8) bei sender-aus oder zuviel unterspannung wieder anlaufsicherung	
notpgm
	bsf	PORTA,motor	; motor aus bei problemen
	bcf	stabyb,2	; lsche fehlerbit erst mal
	bcf	stabyb,0	; *12) lsche 'akkute unterspg'
	bcf	PORTA,led	; *6) 
	movlw	d'10'		; *8) statt 5, betrieb erst nach x richtigen
	movwf	sreg		; imp hintereinander wieder betrieb mglich
fesch1
	clrwdt			; *4)
	MOVLW	88H		; RBIE(port B change interr.) + GIE
	MOVWF	INTCON		; interrupt mglich	
xfesch2
	btfss	PORTA,setu	; setup? (muss auch von da aus gehen)
	call	setup		; ja
	btfsc	INTCON,RBIE	; wird bei impuls gelscht (interrupt)
	goto	fesch1		; nein, noch kein impuls
	btfsc	stabyb,3	; puls ok ?
	goto	notpgm		; nein von vorne testen
	decfsz	sreg,1		; nach x gutimpulsen gehts wieder
	goto	fesch1		; nchsten impuls testen
	movlw	1
	movwf	fanz		; unbelastet von fehlerimpulsen beginnen
	btfsc	stabyb,1	; *8) auch nach sender aus, wird erst nach gas aus gestartet
	goto	genloop		; kein neustart, keine gas-aus-prfung

;-------------------------------------------------------------------
				;sender drfte wieder funktionieren
	movf	tein,1		;tein=0 --> anlauf mgl.
	btfss	STATUS,Z
	goto	notpgm		;gas nicht auf aus, wiederholen
	bsf	stabyb,1	;gas ist auf aus --> betrieb mglich
	movlw	77H		;*4)
	movwf	anlauf		;*4)bei reset keine anlaufsperre
	movf	tmax,0
	movwf	terl		;*14) keine unterspannungsbegr.

;	motor-freischaltpieps
;------------------------------
	bcf	PORTB,bremse	; bremse aus bei motorpieps
	call	piep		; pieps mit ca 1/4 sec
	call	wartmal
	call	piep		; pieps mit ca 1/4 sec
	call	wartmal
	call	piep		; pieps mit ca 1/4 sec
	goto	genloop		; 

;	up-motor-freischaltpieps
;--------------------------------
piep	
	clrf	durchl
piep1
	bcf	PORTA,motor	; motor ein
	movlw	d'6'
	movwf	arb1
piep2
	decfsz	arb1,1
	goto	piep2

test8	bsf	PORTA,motor	; motor aus 
	call	wartms		; warte 1 ms
	decfsz	durchl,1
	goto	piep1
	return



;	prfe, ob gebremst werden muss, da tein = 0
;	-------------------------------------------
prbre			
	btfsc	PORTB,bremse	; *8) ist schon eingebremst?
	goto	cset		; *8) ja, dann wieder raus		

	bsf	PORTA,motor	;motor aus	;*5) "Motor aus" hierher verlegt, da tein + taus =0 sein knnte --> undef.zustand

	btfsc	stabya,6	;bremsbit schon gesetzt?
	goto	pr0		;ja, nach 255 durchl bremsen
	bsf	stabya,6	;setze bremsbit
	clrf	breza		;
	goto	cset
pr0
	decfsz	breza,1
	goto	cset		;nein, noch nicht bremsen	
	call	bremsl		;B r e m s e n
	bcf	stabya,6	;frs nchste bremsen
	goto	cset

;------------------------------------------------------------------------
;	schneller Bremstakt (z. Zt. nicht verwendet, da Billig-Brems-Fet)
;------------------------------------------------------------------------
bremss				; *8) softbremse
	bsf	PORTA,motor	; motor aus
	btfss	stabya,4	; *8) nur bremsen, wenn bei setup programmiert
	return			;bremse nicht programmiert

	btfss	stabya,5	; *8) Softbremse?
	goto	brems01		; nein --> vollbremsen
	movlw	1
	movwf	teinz		;mit kleinem Bremsverhltnis anfangen
	movlw	d'253'
	movwf	tausz

brems0
	movlw	d'2'
	movwf	durchl		;bestimmt die Dauer bis zur Vollbremsung

brems00	movf	teinz,0
	movwf	arb1
	movf	tausz,0
	movwf	arb2
	call	brezyk		;arbi1 und arbi2 abarbeiten
	decfsz	durchl,1
	goto	brems00		;dieses Brems-Pausenverhltnis nochmal
	incf	teinz,1
	decfsz	tausz,1
	goto	brems0		;mit nchstem Verhltnis bremsen
brems01	bsf	PORTB,bremse	;entgltig bremse ein
	return	
;--------------------------------------------------------------
brezyk
	clrwdt
	bsf	PORTB,bremse	;bremse ein
brems1	decfsz	arb1,1
	goto	brems1
	bcf	PORTB,bremse	;bremse aus
brems2	decfsz	arb2,1
	goto	brems2

	return

;--------------------------------------------------------------
;	langsamer Bremstakt
;--------------------------------------------------------------
bremsl				; *8) softbremse
	bsf	PORTA,motor	; motor aus
	btfss	stabya,4	; *8) nur bremsen, wenn bei setup programmiert
	return			; bremse nicht programmiert

	btfss	stabya,5	; *8) Softbremse?
	goto	bremsl1		; nein --> vollbremsen
test9	movlw	d'80'		; *11) statt 120
	movwf	teinz		; mit dem Bremsverhltnis 1:1 anfangen
	movlw	d'80'		; *11) statt 120
	movwf	tausz

bremsl0
	movf	teinz,0
	movwf	arb1
	movf	tausz,0
	movwf	arb2

	call	brezykl		; arbi1 und arbi2 abarbeiten

;	pruefe auf gas waehrend softbremse
;	----------------------------------

	btfsc	stabyb,0	; wenn bremsen wegen unterspannung, keine unterbrech. moeglich
	goto	bre1		; *11) 
	movf	tein,1		; *11) gas?
	btfsc	STATUS,Z	; *11) 
	goto	bre2		; *11) gas noch immer aus
	bcf	PORTB,bremse	; *11) bremse aus, da wieder leistung
	return			; *11) 
	
bre2	incf	teinz,1
	decfsz	tausz,1
	goto	bremsl0		; mit nchstem Verhltnis bremsen
bremsl1	bsf	PORTB,bremse	; entgltig bremse ein
	return	


;	up bremszyklus
;--------------------------------------------------
brezykl
	bsf	PORTB,bremse	;bremse ein, arbi1
bremsx	movlw	d'10'		;
	movwf	durchl		;
bre0
	clrwdt
	MOVLW	88H		; *11) RBIE(port B change interr.) + GIE yyy
	MOVWF	INTCON		; *11) interrupt mglich
	decfsz	durchl,1
	goto	bre0
	decfsz	arb1,1
	goto	bremsx
;--------------------------------------------------
	bcf	PORTB,bremse	;bremse aus, arbi2
bremsy	movlw	d'10'		;
	movwf	durchl		;
bre1
	clrwdt
	MOVLW	88H		; *11) RBIE(port B change interr.) + GIE yyy
	MOVWF	INTCON		; *11) interrupt mglich
	decfsz	durchl,1
	goto	bre1
	decfsz	arb2,1
	goto	bremsy

	return
;**************************************************************************


;--------------------------------------------------------------------------
;	Unterprogramme
;--------------------------------------------------------------------------


;	oszillator bedienen
;	--------------------
bedosci
	btfss	PORTA,osci	;oscillator fr spg-verdopp. bedienen
	goto	oscihi		;hochschalten
	bcf	PORTA,osci	;tiefschalten
	return	
oscihi
	bsf	PORTA,osci	;oscillator: hochschalten
	return	
;-----------------------------------------------------------------

;	warten
;	------
wart	movlw	0		;achtung, ndert timer
warte0
	BCF	INTCON,T0IF	;lsche Timer-Flag	
	MOVWF	TMR0		;w rein in den Timer
warte				;warterei
	clrwdt			;*4)
	BTFSS   INTCON,T0IF     ;wait for TMR0,  
	GOTO    warte		;255-(tvor+tein/taus) abwarten
	BCF	INTCON,T0IF	;lsche Timer-Flag
	return
;--------------------------------------------------------------------------

;	lese eeprom-zelle
;	-----------------
eeread			;lese byte aus eeprom (adr in w)
	movwf	EEADR		; in w muss adresse stehen
	bsf	STATUS,RP0  	; selects upper memory page
	bsf	EECON1,RD   	; causes an EEPROM read
	bcf	STATUS,RP0  	; go back to lower memory page
	movf	EEDATA,0
	return

;	schreibe eeprom-zelle
;	---------------------
eewrite
	movwf	EEADR		; in w muss adresse stehen
	bcf	INTCON,GIE	; disable interrupts during this sequence
	btfsc	INTCON,GIE	; check that it got disabled
	goto	eewrite  	; try again if not
	bsf	STATUS,RP0     	; select upper memory page
	bsf	EECON1,WREN    	; enable EEPROM writes
	bcf	EECON1,EEIF    	; clear the EEIF flag

	;; the magic sequence must be executed exactly as shown with
	;; interrupts disabled to prevent other instructions from
	;; sneaking in.
	movlw	55h      	; Magic write sequence 
	movwf	EECON2   	; Magic write sequence
	movlw	0AAh     	; Magic write sequence
	movwf	EECON2   	; Magic write sequence
	bsf	EECON1,WR       ; Magic write sequence
	nop             ; allow a short settling time (needed?)
wait_wr_done
	clrwdt               	; prevent watchdog timeouts during the write
	btfsc	EECON1,WR            ; Is the write complete?
	goto	wait_wr_done  	; No. Wait some more
	bcf	STATUS,RP0      ; Yes, go back to lower memory page
	return
;--------------------------------------------------------------------------

;--------------------------------------------------
;   Unterprogr. hole gashebel-stellung (aus setup)
;--------------------------------------------------
getipakt
	movlw	88H		;setze gie + rbie (interrupt mglich)
	movwf	INTCON
loop1	
	clrwdt			;*4)
	btfsc	INTCON,RBIE	;prfe, ob schon interrupt war
	goto	loop1		;nein
	btfsc	PORTB,empf	;war es pos flanke, dann luft mess.
	goto	getipakt	;ja
	return			;messung ist in ipakt
;--------------------------------------------------------------------------


;--------------------------------------
;	up warten bis taste losgelassen
;--------------------------------------
wlos
	bcf	PORTA,led	;led lschen, whrend gedrckt
	call	wartmal		;wegen prellen
wte
	clrwdt			;*4)
	btfss	PORTA,setu	;warten, bis taste losgelassen wird
	goto	wte
	call	wartmal	
	bsf	PORTA,led	;led nach loslassen wieder anznden 
	return

;------------------------------------------------------------
;	up teste auf vollausschlag (aus setup)
;------------------------------------------------------------

test
	bcf	stabyb,7	;kennzeichen fr vollausschlag
	movlw	d'10'		;wenn ipakt+10 > ipmax --> vollausschlag
	addwf	ipakt,0		;ipakt+10 ins w
	subwf	ipmax,0		;(ipakt+10)-ipmax
	btfss	STATUS,C	;prfe carry-bit
	goto	lang		;war ein langer impuls, kein rev-->mit Bremse

kurz	btfsc	stabya,0	;kurz+rev-->mit bremse
	bsf	stabyb,7	
	return
lang	btfss	stabya,0	;reversbetrieb?
	bsf	stabyb,7	;lang und kein rev-->mit bremse
	return



; ***************************************************************************
; interrupt routine,	bei Eintreffen einer Empfngerflanke,
;			bei pos.Flanke:	rcksetzen des timers
;			bei neg.Flanke: Einschaltzeiten berechnen
; ***************************************************************************

interr
	; Sichern von W und STATUS
	;-------------------------
PUSH 	MOVWF 	W_TEMP 		; Copy W to TEMP register,
	SWAPF 	STATUS, W 	; Swap status to be saved into W
	MOVWF 	STATUS_TEMP 	; Save status to STATUS_TEMP register
	BTFSC	PORTB,empf 	; positive od neg. Flanke ?
	goto 	POP		; pos., l timer: ma fr imp-lnge

	;neg Flanke: zeiten berechnen
;	-------------------------------
NEG

	movf	TMR0,0		;impulslnge ins w
	btfsc	INTCON,T0IF	;timerberlauf darf nicht gewesen sein
	goto	fehlimp		;zu langer impuls
	movwf	ipakt		;impulslnge sichern
	btfsc	stabya,7	;kennzeichen 'setup luft'
	goto	POP		;dann nur ipakt liefern

	bsf	PORTA,osci		;oscillator: hochschalten


;	|-----tvor-----|-----taus----|-tein=ipakt-ipmin-|
;	|						|							
;	|--------------|-------tmax = ipmax-ipmin-------|
;	|						|
;	|------------------- 255 -----------------------|

;	ipakt muss zwischen ipmin u ipmax liegen
;-----------------------------------------------


ipkor
	movf	ipakt,0
	subwf	ipmax,0		;ipmax-ipakt-->w
	btfsc	STATUS,C	;prfe carry-bit
	goto	olok		;alles ok, ipakt ist kleiner
	addlw	dist2		;wenn carry, dann imp im bereich
	btfss	STATUS,C	
	goto	fehlimp		;zu langer impuls	
	movf	ipmax,0
	movwf	ipakt		;begrenzen
olok	movf	ipmin,0		;*8)
	subwf	ipakt,0		;ipmin-ipakt-->w
	btfsc	STATUS,C
	goto	olok1		;ipakt war nicht kleiner ipmin
	addlw	dist2
	btfss	STATUS,C	
	goto	fehlimp		;zu kurzer impuls
	movf	ipmin,0
	movwf	ipakt		;begrenzen
olok1
;	gutimpuls: fehlerregister erniedrigen
;	-------------------------------------
	bcf	stabyb,3	;fehlerbit fr diesen imp.,wird bei fehlimp ges.
	decfsz	fanz,1
	goto	olok2
	incf	fanz,1		;negativ darf fehleranzahl nicht werden
olok2	clrf	senda		;sender noch da
	movlw	3
	movwf	senda1		;*13)
	bcf	PORTA,osci	;oscillator: tiefschalten

;	tein/taus berechnen
;	-------------------
;	ipmax - ipmin 	--> tmax	zyklusdauer
;	ipakt-ipmin	--> tein	dauer motor ein
;	tmax - tein	--> taus	dauer motor aus

	movf	ipmin,0		;ipmin --> w
	subwf	ipakt,0		;ipakt-ipmin-->w

;	wenn stabya bit 0 = 1 dann revers und taus/tein vertauschen
;------------------------------------------------------------------
	movwf	tein		;und nach tein abspeichern
	movwf	taus		
	subwf	tmax,0		;tmax-tein --> w
	btfsc	stabya,0	;bit0=1:revers
	goto	rev
	movwf	taus		;und nach taus abspeichern
	goto	ptein0
rev	movwf	tein		;ipmin=vollgas

ptein0	bsf	PORTA,osci	;oscillator: hochschalten

;	wenn tein oder taus fast 0, dann 0 setzen
;	*8) wird ersetzt durch ipmin/ipmax korrektur beim setup
;--------------------------------------------------------------
ptein
	bcf	PORTA,led	;led nur bei vollgas , vorher lschen 
	movf	tein,1		; *8) tein = 0 ??
	btfss	STATUS,Z	; *8)
	goto	ptein1		; *8)

;	tein = 0 (Gashebel)
;	-------------------
	movf	tmax,0		;*12)
	movwf	terl		;*12) reset drosselung bei gas aus	
	goto	weit0		

;	tein > 0
;	--------
ptein1
	bcf	PORTB,bremse	;*8) lse bremse, es braucht scheinbar zeit
				;*12):
	decfsz	uspgz,1		;*9) nach 20*5 ms terl vorsichtig vergr
	goto	ptein2		;*9) noch nicht so weit
	movlw	d'5'		;*9) 5 durchlaeufe: 0,1 sec
	movwf	uspgz		;*9) zhler wieder rcksetzen

	incf	terl,1		;*9)*12) und drosselung vermindern
test21	movf	terl,0
	subwf	tmax,0
	btfss	STATUS,C
	decf	terl,1		;terl reduzieren auf <= tmax		

;	drosselung beruecksichtigen *12)
;	---------------------------
ptein2
	movf	tein,0		;tein reduzieren auf <= terl
	subwf	terl,0
	btfsc	STATUS,C
	goto	ptaus
	sublw	0	
	
	addwf	taus,1
	subwf	tein,1		;--> einschaltzeit wegen unterspannung reduzieren




ptaus
	movf	taus,1		; *8)
	btfss	STATUS,Z	; *8)
	goto	weit0		; taus > 0	; *8)

	btfsc	stabyb,1	;led nur wenn anlauf-sicherung gelst
	bsf	PORTA,led	;led bei vollgas 

;	*8) softanlauf
;----------------------------

weit0				; *8)
	btfss	stabya,3	; softanlauf?
	goto	weit2		; nein 
	movf	tein,0		
	subwf	tealt,0
	btfss	STATUS,C	; tein grsser als letzter wert?
	goto	weit1		; ja
 	movf	tein,0
	movwf	tealt		; aktuelle tein sichern
	movf	taus,0
	movwf	taalt		; aktuelle taus sichern
	goto	weit2

weit1				;werte nur um x verndern, wegen softanlauf
	bcf	PORTA,led	;led nicht whrend softanlauf
	movf	tealt,0		;einschaltzeit nur um x erhhen
	addlw	2		;wert bestimmt, wie softy der anlauf ist
	movwf	tealt
	movwf	tein	

	movlw	2		;ausschaltezeit auch nur um x ndern
	subwf	taalt,0
	btfsc	STATUS,C
	goto	weit11	

weit10
	clrf	taalt
	clrf	taus
	goto	weit2

weit11	movwf	taalt
	movwf	taus
		
weit2				

	; W und STATUS retour	;und wieder aus interrupt heraus
	;-------------------------------------------------------
POP
	bcf	PORTA,osci	; oscillator: tiefschalten
	bcf	INTCON,RBIE	; kennzeichen dass interrupt war
	BCF	INTCON,T0IF	; lsche Timer-Flag
	clrf	TMR0
	SWAPF 	STATUS_TEMP, W 	; Swap nibbles in STATUS_TEMP register
				; and place result into W
	MOVWF 	STATUS 		; Move W into STATUS register
				; (sets bank to original state)
	SWAPF 	W_TEMP, F 	; Swap nibbles in W_TEMP and place result in W_TEMP
	SWAPF 	W_TEMP, W	; Swap nibbles in W_TEMP and place result into W


	RETFIE			;zurck aus Interrupt

;************************************************************************************

;-----------------------------------------------------------
;	setup-modus:	ipmax u ipmin auf empfnger abstimmen
;------------------------------------------------------------
setup				; setup-taster ist gedrckt
	bsf	PORTA,led	; led anznden
	bsf	PORTA,motor	; motor muss sowieso aus sein
	clrf	INTCON		; disable interrupts during this sequence
	btfsc	INTCON,GIE	; check that it got disabled
	goto	setup	  	; try again if not

wta
	clrwdt			;*4)
	btfss	PORTA,setu	;warten, bis taste losgelassen wird
	goto	wta

wend
	bsf	stabya,7	;kennzeichen setup fr interrupt-routine
	call	wartmal		;warten, wegen prellen


	CLRF    ipmax
	movlw	d'255'
	movwf	ipmin

;min/max werte einstellen
;------------------------
set0
	clrwdt			;*4)
	call	getipakt	;hole gashebelstellung nach ipakt
	btfss	PORTA,setu	;setup gedrckt?
	goto	setnext		;ja, weiter zu EMK-Bremse
				;nein, es luft noch min/max-kalibrierung
	movf	ipakt,0		;ja: Impulslng v.Empf-->w
	subwf	durchl,0	;wert wird nur verwenden,
				;wenn er gleich mit letztem war
	btfsc	STATUS,Z
	goto	wok		;ja, war gleich, wert korrekt
	movf	ipakt,0		;ipakt-->w
	movwf	durchl		;nicht gleich: wert sichern (strimpuls?)
	goto	set0
wok	movf	ipakt,0		;ipakt-->w
	subwf	ipmax,0		;ipmax-ipakt-->w, carry wenn ipmax>=ipakt
	btfsc	STATUS,C	;prfe carry-bit
	goto	next0		;alles ok, ipmax ist grsser
	movf	ipakt,0		;ins w
	movwf	ipmax		;maximalwert richtigstellen	
	bsf	stabya,0	;bit0 gesetzt: maximalwert zuletzt abgespeich.
next0	movf	ipakt,0		;Impulslng v.Empf-->w
tst2	subwf	ipmin,0		;ipmin-ipakt-->w, carry wenn ipmin>=ipakt
	btfss	STATUS,C	;prfe carry-bit
	goto	set0		;alles ok, ipmin ist kleiner

	movf	ipakt,0		;aktuelle imp-lnge ins w
	movwf	ipmin		;minimalwert richtigstellen	
	bcf	stabya,0	;bit0 gel.: minimalwert zuletzt abgespeich.
	goto	set0		;er werkt noch am gashebel


;   EMK-Bremse progr.
;   -----------------
setnext
	call	wlos		;warte bis taste losgelassen
	bcf	stabya,4	;voreinstellung "ohne bremse"
setbr
	clrwdt			;*4)
	btfss	PORTA,setu	;setup gedrckt?
	goto	brend		;ja	
	goto	setbr

brend				;auswertung ob bremse
	call	getipakt	;hole gashebel
	call	test		;pruefe, ob vollausschlag (mit bremse?)
	btfsc	stabyb,7	;war vollausschlag?
	bsf	stabya,4	;dann mit bremse

softbre
	call	wlos		;warte bis taste losgelassen
	btfss	stabya,4	;hat nur sinn, wenn berhaupt bremse
	goto	softan		;keine bremse --> pruefe, ob softanlauf

;   Soft-Bremse progr.,led blinkt vorher
;   -----------------------------------

	call	wartmal	
	bcf	PORTA,led	;led aus
	call	wartmal	
	bsf	PORTA,led	;led an
	call	wartmal	
	bcf	PORTA,led	;led aus
	call	wartmal	
	bsf	PORTA,led	;led an


	bcf	stabya,5	;voreinstellung ohne softbremse
setbr1
	clrwdt			;*4)
	btfss	PORTA,setu	;setup gedrckt?
	goto	brend1		;ja	
	goto	setbr1

brend1				;auswertung ob bremse
	call	getipakt	;hole gashebel
	call	test		;pruefe, ob vollausschlag (mit softbremse?)
	btfsc	stabyb,7	;war vollausschlag?
	bsf	stabya,5	;dann mit softbremse
	call 	wlos		;warte bis taste losgelassen

;   Soft-Anlauf progr.
;   -----------------------------
softan
	bcf	stabya,3	;voreinstellung ohne softanlauf
setbr2
	clrwdt			;*4)
	btfss	PORTA,setu	;setup gedrckt?
	goto	brend2		;ja	
	goto	setbr2

brend2				;auswertung ob bremse
	call	getipakt	;hole gashebel
	call	test		;pruefe, ob vollausschlag (mit bremse?)
	btfsc	stabyb,7	;war vollausschlag?
	bsf	stabya,3	;dann mit softanlauf
	call wlos		;warte bis taste losgelassen

;	setup-ende --> werte ins eeprom sichern
;	---------------------------------------
sete
	clrwdt			;*4)
	bsf	stabyb,2	;setze fehlerbit, initiiert aus genloop
				;sprung ins notprogramm (wegen bentigter motor-freischaltung)
	bcf	stabyb,1	;anlaufsicherung aktivieren
	btfss	PORTA,setu	;prfe, ob setup noch gedrckt
	goto	sete		;ja --> erneut pruefen
	call	wartmal		;warten wegen tasten prellen

	movlw	d'51'		;kennzeichen daten vorh.
	movwf	EEDATA
		
	movlw	0		;auf adr 0
	call	eewrite		;abspeichern

	movf	ipmin,0
	addlw	dist1		; *8) damit der knppel immer im setup-bereich liegt	
	movwf	ipmin
	movwf	EEDATA
	movlw	1		;adresse 1 in eeprom
	call	eewrite		;abspeichern


	movlw	dist1		; *8) damit der knppel immer im setup-bereich liegt
	subwf	ipmax,1
	movf	ipmax,0
	movwf	EEDATA
	movlw	2		;adresse 2 in eeprom
	call	eewrite		;abspeichern

	bcf	stabya,7	;kennz.setup luft lschen
	movf	stabya,0	;staby-->w
	movwf	EEDATA
	movlw	3		;adresse 3 in eeprom
	call	eewrite		;abspeichern

	movf	ipmin,0		;impulsdauer-min ins w-reg
	subwf	ipmax,0		;	"   -min von max abziehen-->w
	movwf	tmax		;Ergebnis nach tmax

	sublw	D'255'		;255 - tmax -->w
	movwf	tvor		;in tvor(lauf) abspeichern
noset
	call	wartmal		;wegen tasten prellen
	bcf	stabya,7	;kennzeichen setup fr interrupt-routine l


	bcf	PORTA,led	;led wieder aus
	return



;------------------------------------------------------------
;	fehlerhaften impuls empfangen
;------------------------------------------------------------
fehlimp
	bsf	stabyb,3	;fehlerbit fr diesen imp.setzen, fuer notpgm 
	incf	fanz,1		;erhhe fehleranzahl, ab x setze fehlerbit
	movf	fanz,0
	sublw	ftol		;fehlertoleranz
	btfsc	STATUS,C
	goto	POP		;noch nicht notprogramm

;	toleranz berschritten --> notprogramm einleiten
;	------------------------------------------------------------------
	bsf	stabyb,2	;fehlerimpulsbit wird in genloop behandelt
	goto	POP

;------------------------------------------------------------------------

wartmal
	call	wartml
	call	wartml
	call	wartml
	call	wartml
	return


wartml				; 65,54 ms , (523 us bei presc0)
	clrf	TMR0		; *8) achtung, ndert timer
	movlw	47H		; set prescaler tmr0
	BSF     STATUS,RP0      ; select register bank 1
	movwf	OPTREG		;
	BCF     STATUS,RP0      ; reselect bank 0
	BCF	INTCON,T0IF	; lsche Timer-Flag	

wrte				; warterei
	clrwdt			; *4)
	BTFSS   INTCON,T0IF     ; wait for TMR0,  
	GOTO    wrte		;
	BCF	INTCON,T0IF	; lsche Timer-Flag
	BSF     STATUS,RP0      ; select register bank 1
	movlw	presc		; asign prescaler 1:x to tmr0?
	movwf	OPTREG		; da sonst timer berluft
	BCF     STATUS,RP0      ; reselect bank 0
	return

;	warte 1 ms
;	-------------
wartms				; 65,54 ms , (523 us bei presc0)
	clrf	TMR0		; *8) achtung, ndert timer
	movlw	41H		; set prescaler tmr0
	BSF     STATUS,RP0      ; select register bank 1
	movwf	OPTREG		;
	BCF     STATUS,RP0      ; reselect bank 0
	BCF	INTCON,T0IF	; lsche Timer-Flag	

wrtms				; warterei
	clrwdt			; *4)
	BTFSS   INTCON,T0IF     ; wait for TMR0,  
	GOTO    wrtms		;
	BCF	INTCON,T0IF	; lsche Timer-Flag
	BSF     STATUS,RP0      ; select register bank 1
	movlw	presc		; asign prescaler 1:x to tmr0???????????????????
	movwf	OPTREG		; da sonst timer berluft
	BCF     STATUS,RP0      ; reselect bank 0
	return

;	--------------------------
;	Unterspannung aufgetreten
;	--------------------------
;	terl wird verkleinert (tein,taus-anpassung im interrupt)
;
untersp				;kommt nur hierher, wenn tein >0
	bsf	PORTA,motor	;motor aus


	movlw	5		;akkute untersp?
	subwf	terl,0
	btfss	STATUS,C
	goto	usp1		;*12) akkute unterspannung--> bremsen, anlaufsi.
usp0
	decf	terl,1		;*12) erlaubte einschaltzeit

	movf	tein,1
	btfsc	STATUS,Z
	goto	aweit0		;einschaltzeit ist schon 0

	incf	taus,1
	decf	tein,1		
	goto	aweit0	

;	akkute Unterspannung 
;	---------------------
usp1
	bsf	stabyb,0	;*12) kennzeiche 'akk. uspg'
	call	bremsl		;*12) bremsen
	goto	notp		;*12) anlaufsicherung
	goto	notp
;***********************************************************

	org	210AH
	DE      "Copyright (C) 1999 Hans Aichinger"

	END

